
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2016 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/**
*  @file gsiDeclQToolTip.cc 
*
*  DO NOT EDIT THIS FILE. 
*  This file has been created automatically
*/

#include "gsiQtGui.h"
#include "gsiDeclQtTypeTraits.h"
#include "gsiDeclQToolTip_Enums.h"
#include <memory>

// -----------------------------------------------------------------------
// class QToolTip

// static QFont QToolTip::font()


static void _init_f_font_0 (qt_gsi::GenericStaticMethod *decl)
{
  decl->set_return<QFont > ();
}

static void _call_f_font_0 (const qt_gsi::GenericStaticMethod *decl, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  ret.write<QFont > ((QFont)QToolTip::font ());
}

static qt_gsi::GenericStaticMethod *_create_f_font_0 ()
{
  return new qt_gsi::GenericStaticMethod (":font", "@brief Static method QFont QToolTip::font()\nThis method is static and can be called without an instance.", &_init_f_font_0, &_call_f_font_0);
}

// static void QToolTip::hideText()


static void _init_f_hideText_0 (qt_gsi::GenericStaticMethod *decl)
{
  decl->set_return<void > ();
}

static void _call_f_hideText_0 (const qt_gsi::GenericStaticMethod *decl, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  QToolTip::hideText ();
}

static qt_gsi::GenericStaticMethod *_create_f_hideText_0 ()
{
  return new qt_gsi::GenericStaticMethod ("hideText", "@brief Static method void QToolTip::hideText()\nThis method is static and can be called without an instance.", &_init_f_hideText_0, &_call_f_hideText_0);
}

// static bool QToolTip::isVisible()


static void _init_f_isVisible_0 (qt_gsi::GenericStaticMethod *decl)
{
  decl->set_return<bool > ();
}

static void _call_f_isVisible_0 (const qt_gsi::GenericStaticMethod *decl, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  ret.write<bool > ((bool)QToolTip::isVisible ());
}

static qt_gsi::GenericStaticMethod *_create_f_isVisible_0 ()
{
  return new qt_gsi::GenericStaticMethod ("isVisible?", "@brief Static method bool QToolTip::isVisible()\nThis method is static and can be called without an instance.", &_init_f_isVisible_0, &_call_f_isVisible_0);
}

// static QPalette QToolTip::palette()


static void _init_f_palette_0 (qt_gsi::GenericStaticMethod *decl)
{
  decl->set_return<QPalette > ();
}

static void _call_f_palette_0 (const qt_gsi::GenericStaticMethod *decl, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  ret.write<QPalette > ((QPalette)QToolTip::palette ());
}

static qt_gsi::GenericStaticMethod *_create_f_palette_0 ()
{
  return new qt_gsi::GenericStaticMethod (":palette", "@brief Static method QPalette QToolTip::palette()\nThis method is static and can be called without an instance.", &_init_f_palette_0, &_call_f_palette_0);
}

// static void QToolTip::setFont(const QFont &)


static void _init_f_setFont_1801 (qt_gsi::GenericStaticMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("arg1");
  decl->add_arg<const QFont & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setFont_1801 (const qt_gsi::GenericStaticMethod *decl, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  const QFont &arg1 = args.read<const QFont & > ();
  QToolTip::setFont (arg1);
}

static qt_gsi::GenericStaticMethod *_create_f_setFont_1801 ()
{
  return new qt_gsi::GenericStaticMethod ("setFont|font=", "@brief Static method void QToolTip::setFont(const QFont &)\nThis method is static and can be called without an instance.", &_init_f_setFont_1801, &_call_f_setFont_1801);
}

// static void QToolTip::setPalette(const QPalette &)


static void _init_f_setPalette_2113 (qt_gsi::GenericStaticMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("arg1");
  decl->add_arg<const QPalette & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setPalette_2113 (const qt_gsi::GenericStaticMethod *decl, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  const QPalette &arg1 = args.read<const QPalette & > ();
  QToolTip::setPalette (arg1);
}

static qt_gsi::GenericStaticMethod *_create_f_setPalette_2113 ()
{
  return new qt_gsi::GenericStaticMethod ("setPalette|palette=", "@brief Static method void QToolTip::setPalette(const QPalette &)\nThis method is static and can be called without an instance.", &_init_f_setPalette_2113, &_call_f_setPalette_2113);
}

// static void QToolTip::showText(const QPoint &pos, const QString &text, QWidget *w)


static void _init_f_showText_5040 (qt_gsi::GenericStaticMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("pos");
  decl->add_arg<const QPoint & > (argspec_0);
  static gsi::ArgSpecBase argspec_1 ("text");
  decl->add_arg<const QString & > (argspec_1);
  static gsi::ArgSpecBase argspec_2 ("w", true, "0");
  decl->add_arg<QWidget * > (argspec_2);
  decl->set_return<void > ();
}

static void _call_f_showText_5040 (const qt_gsi::GenericStaticMethod *decl, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  const QPoint &arg1 = args.read<const QPoint & > ();
  const QString &arg2 = args.read<const QString & > ();
  QWidget *arg3 = args ? args.read<QWidget * > () : (QWidget *)(0);
  QToolTip::showText (arg1, arg2, arg3);
}

static qt_gsi::GenericStaticMethod *_create_f_showText_5040 ()
{
  return new qt_gsi::GenericStaticMethod ("showText", "@brief Static method void QToolTip::showText(const QPoint &pos, const QString &text, QWidget *w)\nThis method is static and can be called without an instance.", &_init_f_showText_5040, &_call_f_showText_5040);
}

// static void QToolTip::showText(const QPoint &pos, const QString &text, QWidget *w, const QRect &rect)


static void _init_f_showText_6724 (qt_gsi::GenericStaticMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("pos");
  decl->add_arg<const QPoint & > (argspec_0);
  static gsi::ArgSpecBase argspec_1 ("text");
  decl->add_arg<const QString & > (argspec_1);
  static gsi::ArgSpecBase argspec_2 ("w");
  decl->add_arg<QWidget * > (argspec_2);
  static gsi::ArgSpecBase argspec_3 ("rect");
  decl->add_arg<const QRect & > (argspec_3);
  decl->set_return<void > ();
}

static void _call_f_showText_6724 (const qt_gsi::GenericStaticMethod *decl, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  const QPoint &arg1 = args.read<const QPoint & > ();
  const QString &arg2 = args.read<const QString & > ();
  QWidget *arg3 = args.read<QWidget * > ();
  const QRect &arg4 = args.read<const QRect & > ();
  QToolTip::showText (arg1, arg2, arg3, arg4);
}

static qt_gsi::GenericStaticMethod *_create_f_showText_6724 ()
{
  return new qt_gsi::GenericStaticMethod ("showText", "@brief Static method void QToolTip::showText(const QPoint &pos, const QString &text, QWidget *w, const QRect &rect)\nThis method is static and can be called without an instance.", &_init_f_showText_6724, &_call_f_showText_6724);
}

// static QString QToolTip::text()


static void _init_f_text_0 (qt_gsi::GenericStaticMethod *decl)
{
  decl->set_return<QString > ();
}

static void _call_f_text_0 (const qt_gsi::GenericStaticMethod *decl, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  ret.write<QString > ((QString)QToolTip::text ());
}

static qt_gsi::GenericStaticMethod *_create_f_text_0 ()
{
  return new qt_gsi::GenericStaticMethod ("text", "@brief Static method QString QToolTip::text()\nThis method is static and can be called without an instance.", &_init_f_text_0, &_call_f_text_0);
}


namespace gsi
{
gsi::Class<QToolTip> decl_QToolTip ("QToolTip",
  gsi::Methods(_create_f_font_0 ()) +
  gsi::Methods(_create_f_hideText_0 ()) +
  gsi::Methods(_create_f_isVisible_0 ()) +
  gsi::Methods(_create_f_palette_0 ()) +
  gsi::Methods(_create_f_setFont_1801 ()) +
  gsi::Methods(_create_f_setPalette_2113 ()) +
  gsi::Methods(_create_f_showText_5040 ()) +
  gsi::Methods(_create_f_showText_6724 ()) +
  gsi::Methods(_create_f_text_0 ()),
  "@qt\n@brief Binding of QToolTip");

}

